#pragma once

#ifndef DATETIME_H
#define DATETIME_H

#include "Timepoint.h"

enum Weekday {
	Sunday = 0,
	Monday = 1,
	Tuesday = 2,
	Wednesday = 3,
	Thursday = 4,
	Friday = 5,
	Saturday = 6
};

class DateTime {
public:
	DateTime();
	DateTime(int, int, int);
	DateTime(Timepoint tp);

	int Year();
	int Year(int);
	int Month();
	int Month(int);
	int Day();
	int Day(int);
	double TotalDays();
	int Hour();
	int Hour(int);
	double TotalHours();
	int Minute();
	int Minute(int);
	double TotalMinutes();
	int Second();
	int Second(int);
	double TotalSeconds();
	double Millisecond();
	double TotalMilliseconds();
	double Microsecond();
	double TotalMicroseconds();
	double Nanosecond();
	double Nanosecond(double);
	double TotalNanoseconds();

	void set_timepoint(Timepoint);
	operator Timepoint();

	static int days_from_civil(int, unsigned, unsigned);
	static DateTime civil_from_days(int);
	static Weekday weekday_from_days(int z);
private:
	Timepoint _tp;
	int _year;
	int _month;
	int _day;
	int _hour;
	int _minute;
	int _second;
	double _nanos;

	void updatetp();
};


#endif	//	DATETIME_H