#pragma once

#ifndef TIMER_H
#define TIMER_H

#include "Timepoint.h"
#include "Duration.h"

class Timer {
public:
	Timer();
	Timer(bool);
	Timer(Duration);
	Timer(Duration, bool);
	Timer(bool, void(*_action)(void));
	Timer(Duration, void(*_action)(void));
	Timer(Duration, bool, void(*_action)(void));
	bool Set(Timepoint);
	bool Set(Timepoint, void(*_action)(void));
	bool Set(Duration);
	bool Set(Duration, void(*_action)(void));
	bool Reset();
	bool Reset(Timepoint);
	bool Reset(Duration);
	int Check();
	int checkReturnIfNotSet();
	int checkReturnIfNotSet(int);
	Duration timeoutDuration();
	Duration timeoutDuration(Duration);
	void Cancel();
	bool isSet();
	bool recur();
	bool recur(bool);
private:
	bool _recur = false;
	bool _isSet = false;
	int _ifnotset = false;
	Timepoint _eventTime;
	Duration _timeoutDuration;
	Duration _timerDuration;
	void(*_timerevent)(void);
};

#endif	//	TIMER_H